﻿
@using Jumbula.Common.Helper
@using Jumbula.Core.Domain
@model SportsClub.Models.OrderItemDetailViewModel

@{
    ViewBag.Title = "Order Details";
    ViewBag.IsRegistrantReport = true;
}

<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="title-page">
                <h1> Order details </h1>
            </div>
        </div>
    </div>

    <div class="container-bordered">
        <div class="row">
            <div class="col-md-12">
                <div class="title-details">
                    <h3 class="bold">
                        @Model.ProgramName
                        @switch (Model.ItemStatusReasons)
                        {
                            case OrderItemStatusReasons.regular:
                                @*<i class="label label-success status-reasons">@Model.ItemStatusReasons.ToDescription()</i>*@
                                break;
                            case OrderItemStatusReasons.transferIn:
                                <i class="label label-yellow status-reasons">@Model.ItemStatusReasons.ToDescription()</i>
                                break;
                            case OrderItemStatusReasons.transferOut:
                                <i class="label label-yellow status-reasons">@Model.ItemStatusReasons.ToDescription()</i>
                                break;
                            case OrderItemStatusReasons.canceled:
                                <i class="label label-yellow status-reasons">@Model.ItemStatusReasons.ToDescription()</i>
                                break;
                            default:
                                break;
                        }
                    </h3>
                    <h3 class="schedule-dates"> (@Html.DisplayFor(model => model.ScheduleDate))</h3>
                    <div class="clearfix"></div>
                    <hr>
                </div>

            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <ul class="item-list">
                    <li><span class="bold">Participant:</span> <span>@Html.DisplayFor(model => model.AttendeeName)</span></li>
                    <li><span class="bold">Confirmation:</span> <span>@Model.Confirmation</span></li>
                    <li><span class="bold">Order date: </span><span> @Model.OrderDate.ToString("MMM dd, yyyy")</span></li>
                    <li><span class="bold">@Model.TuitionName: </span>@string.Format("{0}", CurrencyHelper.FormatCurrencyWithPenny(Model.TuitionPrice, Model.Currency))</li>
                    @if (Model.Charges.Count > 0)
                    {
                        <li>

                            <span class="bold">Charges:</span>
                            <div>
                                @foreach (var charge in Model.Charges)
                                {
                                    <div>
                                        <div style="margin-left: 11px;display: inline;">@charge.Name:</div>
                                        <span> @CurrencyHelper.FormatCurrencyWithPenny(charge.Price, Model.Currency) </span>
                                    </div>

                                }
                            </div>
                        </li>
                    }
                    @if (Model.Discounts.Count > 0)
                    {
                        <li>
                            <span class="bold">Discounts:</span>
                            <div>
                                @foreach (var discount in Model.Discounts)
                                {
                                    <div>
                                        <div style="margin-left: 11px;display: inline;">@discount.Name:</div>
                                        <span> @CurrencyHelper.FormatCurrencyWithPenny(discount.Price, Model.Currency) </span>
                                    </div>


                                }
                            </div>
                        </li>
                    }
                    <li><span class="bold">Total amount:</span> <span>@string.Format("{0}", CurrencyHelper.FormatCurrencyWithPenny(Model.TotalAmount, Model.Currency))</span></li>

                    <li><span class="bold">Paid amount:</span> <span>@string.Format("{0}", CurrencyHelper.FormatCurrencyWithPenny(Model.PaidAmount, Model.Currency))</span></li>
                    <li>
                        @if (Model.Balance > 0)
                        {
                            <span class="bold">Balance:</span> <span style="color:#ff0000">@string.Format("{0}", CurrencyHelper.FormatCurrencyWithPenny(Model.Balance, Model.Currency))</span>
                        }
                    </li>
                </ul>
            </div>
        </div>

    </div>

    <div id="order">
        <div class="row order">
            <div class="col-sm-12">

                <div class="Section-OrderDetails" id="installments">

                    <div class="orderitem-section-title-bg">
                        <h2 class="orderitem-section-title">Installments</h2>
                    </div>
                    @if (Model.Installments != null && Model.Installments.Any())
                    {    

                        <div class="parent-grid-custom" id="OrderItemInstallmentsGrid"></div>

                    }
                    else
                    {
                        <div>No data found</div>
                    }

                </div>

                <div id="paymentHistory" class="Section-OrderDetails">
                    <div class="orderitem-section-title-bg">
                        <h2 class="orderitem-section-title">Payment history</h2>
                    </div>
                    <div class="parent-grid-custom" id="OrderItemTransactionsGrid"></div>

                    <div id="EmptyGrid" style="display:none">No data found</div>

                </div>

                <div id="FollowUpForms" class="Section-OrderDetails">
                    <div class="orderitem-section-title-bg">
                        <h2 class="orderitem-section-title"> Follow-up forms</h2>
                    </div>
                    @if (Model.FollowUpForms != null && Model.FollowUpForms.Any())
                    {

                        <table class="table">
                            <thead>
                                <tr>
                                    <th>
                                        Title
                                    </th>
                                    <th>
                                        Status
                                    </th>
                                    <th>
                                        Status
                                    </th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var form in Model.FollowUpForms)
                                {
                                    <tr>
                                        <td>
                                            @form.Title
                                        </td>
                                        <td>
                                            @form.Status.ToDescription()
                                        </td>
                                        <td>
                                            @if (form.Status == FollowupStatus.Completed && Model.ItemStatusReasons != OrderItemStatusReasons.transferOut && form.Type != FormType.UploadForm)
                                            {
                                                <text>
                                                    @Html.Raw(string.Format("<a href={0}>View/Edit</a>", form.Link))
                                                </text>
                                            }
                                            else if (Model.ItemStatusReasons == OrderItemStatusReasons.transferOut)
                                            {
                                                <span>-</span>
                                            }
                                            else if (form.Type != FormType.UploadForm)
                                            {
                                                <text>
                                                    @Html.Raw(string.Format("<a href={0}>Fill it now</a>", form.Link))
                                                </text>
                                            }
                                            else if (form.Type == FormType.UploadForm)
                                            {
                                                <text>
                                                    @Html.Raw(string.Format("<a href={0}>Download</a>", form.Link)) -
                                                </text>

                                                @Html.Raw(string.Format("<a href={0}>Upload</a>", Url.Action("UploadFollowUpForm", "FollowupForm", new { orderItemId = Model.OrderItemId, formId = form.Id, uId = form.Guid })))
                                            }
                                        </td>
                                    </tr>
                                }
                            </tbody>
                        </table>
                    }
                    else
                    {
                        <div>No data found</div>
                    }

                </div>

                <div id="Waivers">
                    <div class="orderitem-section-title-bg">
                        <h2 class="orderitem-section-title">Waivers</h2>
                    </div>
                    @if (Model.ClubWaivers != null && Model.ClubWaivers.Any())
                    {
                        <table class="table">
                            <thead>
                                <tr>
                                    <th>
                                        Title
                                    </th>
                                    <th>
                                        Mandatory
                                    </th>
                                    <th>
                                        Status
                                    </th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var waiver in Model.ClubWaivers)
                                {
                                    <tr>
                                        <td>
                                            @waiver.Name
                                        </td>
                                        <td>
                                            @if (waiver.IsRequired)
                                            {
                                                <span> Yes </span>
                                            }
                                            else
                                            {
                                                <span> No </span>
                                            }
                                        </td>
                                        <td>
                                            @if (waiver.WaiverConfirmationType == WaiverConfirmationType.Agree && waiver.Agreed == true)
                                            {
                                                <text>
                                                    @*@waiver.Status.ToDescription()*@ Agreed - @Html.Raw(string.Format("<a href={0}>View</a>", "waiver/" + @waiver.Id)) @*form.Link*@
                                                </text>
                                            }
                                            else if (waiver.WaiverConfirmationType == WaiverConfirmationType.Agree && waiver.Agreed == false)
                                            {
                                                <text>
                                                    @*@waiver.Status.ToDescription()*@ Declined - @Html.Raw(string.Format("<a href={0}>View</a>", "waiver/" + @waiver.Id)) @*form.Link*@
                                                </text>
                                            }
                                            else if (waiver.WaiverConfirmationType == WaiverConfirmationType.Signature && waiver.Signature != null)
                                            {
                                                <text>
                                                    @*@waiver.Status.ToDescription()*@ Signed - @Html.Raw(string.Format("<a href={0}>View</a>", "waiver/" + @waiver.Id)) @*form.Link*@
                                                </text>
                                            }
                                            else if (waiver.WaiverConfirmationType == WaiverConfirmationType.Signature && waiver.Signature == null)
                                            {
                                                <text>
                                                    @*@waiver.Status.ToDescription()*@ Declined - @Html.Raw(string.Format("<a href={0}>View</a>", "waiver/" + @waiver.Id)) @*form.Link*@
                                                </text>
                                            }
                                        </td>
                                    </tr>
                                }
                            </tbody>
                        </table>
                    }
                    else
                    {
                        <div>No data found</div>
                    }
                </div>

                <div class="clearfix"></div>
            </div>
            <div class="clearfix"></div>
        </div>
    </div>
</div>

@section Styles{
    @Styles.Render("~/bundles/orderStyles")
    @*<link href="~/Content/Student/Dashboard/Order.css" rel="stylesheet" />*@
}

<script src="~/Scripts/Libraries/KendoUI/kendo.all.min.js"></script>
<script>
    function kendoEmptyGridFix() {

        $("[data-role='grid']").each(function () {
            $(this).data("kendoGrid").bind(function (e) {
                kendoEmptyGridFix();
            });
            $(this).data("kendoGrid").bind('dataBound', function (e) {
                var colCount = this.table.find("tHead tr th").length;

                if ($(this)[0].dataSource._view.length == 0) {
                    var msg = ($(this)[0].dataSource.options.emptyMsg == undefined ? "" : $(this)[0].dataSource.options.emptyMsg);
                    this.table.find('tbody').html('<tr class="kendo-data-row"><td colspan="' + colCount + '" style="text-align:center; padding-top:20px; padding-bottom:20px;"><div class="k-empty-grid-row">' + msg + '</div></td></tr>');

                    //$("[data-role='grid']").find('.k-grid-header-wrap').hide();
                    $("#OrderItemTransactionsGrid").hide();
                    $("#EmptyGrid").show();

                };
            });
        });
    }


    function displayLoading(target, status) {
        var element = $(target);
        kendo.ui.progress(element, status);
    }

    var initialLoad = true;

    var grid = $("#OrderItemTransactionsGrid").kendoGrid({
        dataSource: {
            type: "json",
            transport: {
                read: {
                    url: "GetParentOrderItemTransactions?orderItemId=@Model.OrderItemId",
                    dataType: "json"
                },
                parameterMap: function (data, type) {
                    if (type === "read") {
                        return {
                            term: '',
                            skip: data.skip,
                            take: data.take,
                            page: data.page,
                            pageSize: data.pageSize,
                            sort: null
                        }
                    }
                }
            },

            schema: {
                total: "TotalCount",
                data: "DataSource"
            },
            resizable: true,
        },
        groupable: false,
        sortable: true,

        scrollable: {
            virtual: true
        },

        columns: [{
            field: "StrTransactionDate",
            title: "Date",
        },
        {
            field: "StrAmount",
            title: "Amount",
        },
        {
            field: "StrPaymentMethod",
            title: "Payment method",

        },
        {
            field: "StrTransactionStatus",
            title: "Status",
            width: "100px",
        },
        {
            field: "TransactionId",
            title: "Transaction ID",
            width: "250px",
        },
         {
             field: "Note",
             title: "Memo",
             attributes: {
                 title: ""
             }

         }]

    }).data("kendoGrid");
    grid.table.kendoTooltip({
        filter: "td[title]",
        content: function (e) {
            var target = e.target;
            return $(target).text();
        }
    });

    $("#OrderItemInstallmentsGrid").kendoGrid({
        dataSource: {
            type: "json",
            transport: {
                read: {
                    url: "GetOrderItemInstallments?orderItemId=@Model.OrderItemId",
                    dataType: "json"
                },
                parameterMap: function (data, type) {
                    if (type === "read") {
                        return {
                            term: '',
                            skip: data.skip,
                            take: data.take,
                            page: data.page,
                            pageSize: data.pageSize,
                            sort: null
                        }
                    }
                }
            },
            requestStart: function () {

            },
            requestEnd: function () {

            },
            schema: {
                total: "TotalCount",
                data: "DataSource"
            },
            sort:
                [{
                    field: "Id",
                    dir: "asc"
                }],
            resizable: true,
           
        },

        groupable: false,
        sortable: true,
        columnMenu: true,

        scrollable: {
            virtual: true
        },
        dataBound: function () {
            var grid = $('#OrderItemInstallmentsGrid').data('kendoGrid');

            if (grid.dataSource.data()[0].ProgramType != 6 && grid.dataSource.data()[0].ProgramType != 5) {
                grid.hideColumn(0);
            }
        },
        columns: [{
            field: "Schedule",
               title: "Schedule dates",
            },
            {
               field: "StrAmount",
               title: "Amount",
            },
            {
                field: "StrPaidAmount",
               title: "Paid amount",
            },
            {
               field: "StrBalance",
               title: "Balance",
            },
            {
                field: "StrPaidDate",
                title: "Paid date",

            },
            {
                field: "InstallmentStatus",
                title: "Status",
                template: '<div style="color:black;"> #=InstallmentStatus # #if(IsPastDue) { # <i class="label label-red status-reasons">Past due</i> # } #</div><div> \
                #if(PaidAmount!= Amount) { # <div style="color:gray;">Due #=InstallmentDueDate# </div> # } # </div> '
           }],

    });

    $(document).ready(function () {
        kendoEmptyGridFix();
    });


</script>